## listaller 0.5.9

=== CMakeLists.txt ===
# CMakeLists for the Listaller Project
project(listaller)

cmake_minimum_required(VERSION 2.8.6 FATAL_ERROR)

#UNSET THIS VARIABLE AT RELEASE TIME
set(VERSION_SUFFIX "-dev")

set(CMAKE_BUILD_TYPE "Debug")

# Detect Git revision (if present)
if(VERSION_SUFFIX MATCHES "-dev")
	if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/.git)
		find_package(Git)
		if(GIT_EXECUTABLE)
		  execute_process(WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
				    COMMAND ${GIT_EXECUTABLE} rev-parse --short HEAD
				    OUTPUT_VARIABLE project_revision RESULT_VARIABLE check_fail)
		  string(REGEX REPLACE "\n" "" project_revision ${project_revision})
		  if(check_fail)
		   message(STATUS "Could not fetch current Git revision: ${check_fail}")
		  else()
		   message(STATUS "Found Git revision: ${project_revision}")
		   set(VERSION_SUFFIX "${VERSION_SUFFIX}:${project_revision}")
		  endif(check_fail)
		endif(GIT_EXECUTABLE)
	endif()
endif()

set(LISTALLER_VERSION_MAJOR  "0")
set(LISTALLER_VERSION_MINOR  "5")
set(LISTALLER_VERSION_PATCH  "9")
set(LISTALLER_VERSION_SUFFIX "${VERSION_SUFFIX}")
set(LISTALLER_VERSION "${LISTALLER_VERSION_MAJOR}.${LISTALLER_VERSION_MINOR}.${LISTALLER_VERSION_PATCH}")

set(LISTALLER_API_LEVEL "0")

# Forbid in-tree building
if(${CMAKE_SOURCE_DIR} MATCHES ${CMAKE_BINARY_DIR})
      message(STATUS "Please do an out-of-tree build:")
      message(STATUS "rm -f CMakeCache.txt && mkdir build && cd build; cmake .. && make")
      message(FATAL_ERROR "In-tree-build detected!")
endif(${CMAKE_SOURCE_DIR} MATCHES ${CMAKE_BINARY_DIR})

#
# Options
#
option(QT "Build Listaller's Qt4 modules" OFF)
option(TOOLS "Build Listaller's non-gui tools" ON)
option(LIBUILD "Build and install the LIBuild facilities" OFF)
option(PATCHELF "Build patchelf utility" OFF)
option(VISUAL_LDD "Build the Visual-LDD utility" OFF)
option(L10N "Enable localization" ON)
option(API_DOCS "Add target to build API documentation" OFF)
option(TEST_DEPMANAGER "Test Listaller's dependency solver" OFF)
option(TEST_SIGNING "Enable Listaller signing tests" OFF)

if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
  set(CMAKE_INSTALL_PREFIX
    "/usr" CACHE PATH "Listaller default install prefix" FORCE)
endif(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)

set(XDG_APPS_INSTALL_DIR share/applications)

add_definitions(-DCMAKE_INSTALL_PREFIX="\"${CMAKE_INSTALL_PREFIX}\"")
add_definitions(-DCMAKE_INSTALL_LIBDIR="\"${CMAKE_INSTALL_LIBDIR}\"")

set(CMAKE_INSTALL_LIBDIR "lib/${CMAKE_LIBRARY_ARCHITECTURE}" CACHE PATH "Output directory for libraries")
set(LISTALLER_INSTALL_DIR ${CMAKE_INSTALL_LIBDIR}/listaller)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR}/data/cmake/)
list(APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/data/cmake/vala)

message(STATUS "Compiling Listaller version ${LISTALLER_VERSION}")

configure_file("${CMAKE_SOURCE_DIR}/data/cmake/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)

add_custom_target(uninstall
  "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
)

add_custom_target(distclean
  "make clean"
)

#
# l10n
#
find_package (Gettext REQUIRED)

#
# Default paths
#
set(BIN_INSTALL_DIR bin CACHE PATH "Installation directory for executables")
set(LIB_INSTALL_DIR lib/${CMAKE_LIBRARY_ARCHITECTURE} CACHE PATH "Installation directory for libraries")
set(INC_INSTALL_DIR include CACHE PATH "Installation directory for headers")
set(DATA_INSTALL_DIR share/listaller CACHE PATH "Installation directory for data files")
set(SYSCONF_INSTALL_DIR /etc CACHE PATH "Installation directory for system configuration files")

#
# Configure files
#
set (PREFIXDIR "${CMAKE_INSTALL_PREFIX}")
set (DATADIR "${CMAKE_INSTALL_PREFIX}/share")
set (PKGDATADIR "${DATA_INSTALL_DIR}")
set (LIBDIR "${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR}")
set (PKGLIBDIR "${LIBDIR}/listaller")
set (GETTEXT_PACKAGE "listaller")
set (LOCALE_DIR "${DATADIR}/locale")
set (VERSION "${LISTALLER_VERSION}")
set (BUILDDIR "${CMAKE_BINARY_DIR}")

configure_file(config.h.in ${CMAKE_BINARY_DIR}/config.h)
# set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES ${CMAKE_SOURCE_DIR}/src/config.h)

#
# Enable testing
#
enable_testing()

#
# Custom C flags
#
set(MAINTAINER_CFLAGS "-Werror -Wall -Wcast-align -Wno-uninitialized -Wempty-body -Wformat-security -Winit-self")
option(DISABLE_MAINTAINER_CFLAGS "Disable maintainer CFlags" ON)
if(DISABLE_MAINTAINER_CFLAGS)
	set(MAINTAINER_CFLAGS "")
endif(DISABLE_MAINTAINER_CFLAGS)
add_definitions(${MAINTAINER_CFLAGS})

set(GLOBAL_VALAC_FLAGS "--target-glib=2.36")

# Required to include config.h before all other units
add_definitions ("--include config.h")

# Required if GPGme was compiled with _FILE_OFFSET_BITS=64
add_definitions("-D_FILE_OFFSET_BITS=64")

#
# Validate Vala version
#
find_package(PkgConfig REQUIRED)
find_package(Vala REQUIRED)
include(${VALA_USE_FILE})
ensure_vala_version("0.20" MINIMUM)

add_subdirectory(src)
add_subdirectory(tools)
add_subdirectory(data)
add_subdirectory(contrib)
add_subdirectory(tests)
add_subdirectory(docs)
if (GETTEXT_FOUND AND L10N)
  add_subdirectory(po)
endif (GETTEXT_FOUND AND L10N)

=== data/CMakeLists.txt ===

add_subdirectory(etc)
add_subdirectory(metainfo-templates)
add_subdirectory(mime)
add_subdirectory(graphics)

=== docs/CMakeLists.txt ===
# CMakeLists for documentation

add_subdirectory (man)

# Find required tools
find_program (XMLTO xmlto)
mark_as_advanced (XMLTO)
if (XMLTO STREQUAL "")
	message (FATAL_ERROR "Xmlto was not found! Please install it to continue!")
endif (XMLTO STREQUAL "")

find_program (PUBLICAN publican)
mark_as_advanced (PUBLICAN)
if (PUBLICAN STREQUAL "")
	message (FATAL_ERROR "Publican was not found! Please install the it to continue!")
endif (PUBLICAN STREQUAL "")

# build small listaller lib version string
set(LISTALLER_LIB_VERSION "${LISTALLER_VERSION_MAJOR}.${LISTALLER_VERSION_MINOR}.${LISTALLER_VERSION_PATCH}")

# we need to assemble our documentation build-directory before we can built it
add_custom_target (assemble-docs
	COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/prepare-docbuild.sh" "source_dir=${CMAKE_CURRENT_SOURCE_DIR}" "build_dir=${CMAKE_BINARY_DIR}/docbuild"
	DEPENDS "publican.cfg"
		"sources/"
		"${CMAKE_BINARY_DIR}/docbuild/"
		"${CMAKE_BINARY_DIR}/src/liblistaller-glib.so.${LISTALLER_LIB_VERSION}"
	WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
	VERBATIM
)

# the actual target to build all documentation
add_custom_target (documentation
	COMMAND ${PUBLICAN} "build" "--langs=en-US" "--publish" "--formats=html"
	DEPENDS "publican.cfg"
		"${CMAKE_BINARY_DIR}/docbuild/publican.cfg"
		assemble-docs
	WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/docbuild/
)
add_custom_command (OUTPUT "${CMAKE_BINARY_DIR}/docbuild/"
		COMMAND ${CMAKE_COMMAND} -E make_directory "${CMAKE_BINARY_DIR}/docbuild"
		VERBATIM
)

set_directory_properties (PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES ${CMAKE_CURRENT_SOURCE_DIR}/html)
set_directory_properties (PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES ${CMAKE_BINARY_DIR}/docbuild)

# a target to export documentation html to the source tree (useful when building the tarballs)
add_custom_target (documentation-htmlexport
	COMMAND ${CMAKE_COMMAND} -E copy_directory "${CMAKE_BINARY_DIR}/docbuild/Listaller-Docs/en-US/html/" "${CMAKE_CURRENT_SOURCE_DIR}/html"
	DEPENDS documentation
	WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
)

if (API_DOCS)
	# find documentation tools
	find_program (VALADOC valadoc)
	mark_as_advanced (VALADOC)
	if (VALADOC STREQUAL "")
		message (FATAL_ERROR "valadoc was not found! Please install Valadoc to continue!")
	endif (VALADOC STREQUAL "")
	find_program(GTKDOC_SCAN_EXE gtkdoc-scan PATH "${GLIB_PREFIX}/bin")
	if(NOT GTKDOC_SCAN_EXE)
		message(FATAL_ERROR "gtkdoc not found")
	endif(NOT GTKDOC_SCAN_EXE)

	find_path (SYSTEM_VAPI_DIR
		NAMES glib-2.0.vapi
		HINTS "/usr/share/vala-0.??/vapi" "/usr/share/vala")
	# ugly hack to help valadoc finding vapi files
	string (SUBSTRING ${VALA_VERSION} 0 4 VALA_VERSION_SHORT)
	set (SYSTEM_VAPI_DIR "${CMAKE_INSTALL_PREFIX}/share/vala-${VALA_VERSION_SHORT}/vapi")

	# find public library sources
	file (GLOB LISTALLER_LIB_SOURCES_MAIN "${CMAKE_SOURCE_DIR}/src/*.vala")
	file (GLOB LISTALLER_LIB_SOURCES_SOLVERS "${CMAKE_SOURCE_DIR}/src/solvers/*.vala")
	set (LISTALLER_LIB_SOURCES ${LISTALLER_LIB_SOURCES_MAIN} ${LISTALLER_LIB_SOURCES_SOLVERS})

	add_custom_command (TARGET documentation
			COMMAND "valadoc" "--force" "-b" "${CMAKE_SOURCE_DIR}/src" "-o" "${CMAKE_SOURCE_DIR}/docs/api"
			"--vapidir=${CMAKE_SOURCE_DIR}/vapi" "--vapidir=${SYSTEM_VAPI_DIR}"
			"-X" "${CMAKE_BINARY_DIR}/src/listaller.h" "-X" "-l"
			"-X" "${CMAKE_BINARY_DIR}/src/liblistaller-glib.so.${LISTALLER_LIB_VERSION}"
			"--doclet" "gtkdoc"
			"--pkg=config" "--pkg=gee-1.0" "--pkg=gio-2.0" "--pkg=libsoup-2.4"
			"--pkg=sqlite3" "--pkg=libarchive" "--pkg=gpgme" "--pkg=libxml-2.0"
			"--pkg=appstream" "--pkg=packagekit-glib2"
			"--package-name=listaller"
			"--package-version=${LISTALLER_VERSION}"
			"--importdir=${CMAKE_SOURCE_DIR}/docs/man"
			${LISTALLER_LIB_SOURCES}
			VERBATIM)
	set_directory_properties (PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES ${CMAKE_CURRENT_SOURCE_DIR}/api/html)
	set_directory_properties (PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES ${CMAKE_CURRENT_SOURCE_DIR}/api/xml)

endif()

=== src/CMakeLists.txt ===
# CMakeLists for Listaller-GLib (source)

#
# Some general library & source settings
#
set(lisrc ${CMAKE_SOURCE_DIR}/src
	  CACHE INTERNAL "Listaller sourcecode dir"
)

set(LISTALLER_BASE_SOURCES ${lisrc}/logging.vala
	${lisrc}/utils.vala
	${lisrc}/status.vala
	${lisrc}/message-object.vala
	${lisrc}/config-global.vala
	${lisrc}/downloader.vala
	${lisrc}/setup-settings.vala
	${lisrc}/application.vala
	${lisrc}/database-internal.vala
	${lisrc}/software-db.vala
	${lisrc}/software-cache.vala
	${lisrc}/varsolver.vala
	${lisrc}/varsetter.vala
	${lisrc}/ipk-metafile.vala
	${lisrc}/ipk-filelist.vala
	${lisrc}/ipk-control.vala
	${lisrc}/ipk-package.vala
	${lisrc}/gpgex.vala
	${lisrc}/security-info.vala
	${lisrc}/version.vala
	CACHE INTERNAL "Listaller core source files"
)

set(LISTALLER_BASE_VALA_DEPS config gee-1.0 gio-2.0 sqlite3 libarchive libsoup-2.4 gpgme libxml-2.0 appstream
			     CACHE INTERNAL "Essential Vala package dependencies"
)

# Variables used later to set library versioning
set(LILIBS_FULL_VERSION "${LISTALLER_VERSION_MAJOR}.${LISTALLER_VERSION_MINOR}.${LISTALLER_VERSION_PATCH}")
set(LILIBS_VERSION "${LISTALLER_VERSION_MAJOR}.${LISTALLER_VERSION_MINOR}" CACHE INTERNAL "int: LiLibs version")

#
# Build Qt4 library if flag is set
#
if(QT)
	message ("The Qt4 interface is outdated and needs to be rewritten.")
	message ("The rewrite was planned for a later release, if a Qt interface is still useful.")
	#add_subdirectory(qt4)
endif(QT)

#
# Listaller-GLib build instructions
#

find_package(Vala REQUIRED)
include("${VALA_USE_FILE}")

find_package(GLIB2 2.36 REQUIRED)
find_package(Gettext REQUIRED)
find_package(SQLite3 REQUIRED)
find_package(LibArchive REQUIRED)
find_package(LibXml2 REQUIRED)
find_package(GPGMe REQUIRED)
find_package(GI REQUIRED)
find_library(M_LIB m)
pkg_check_modules(GEE REQUIRED gee-1.0>=0.6)
pkg_check_modules(GIO2 REQUIRED gio-2.0>=2.26)
pkg_check_modules(SOUP REQUIRED libsoup-2.4>=2.40)
pkg_check_modules(PACKAGEKIT REQUIRED packagekit-glib2>=0.9.4)
pkg_check_modules(PACKAGEKIT_PLUGIN REQUIRED packagekit-plugin)
pkg_check_modules(APPSTREAM REQUIRED appstream>=0.7.0)
#find_gir(PKGIR "PackageKitGlib-1.0" REQUIRED)

# make sure that the ir-compiler really has been found
# (fixes some compile-issues which have been reported frequently)
if (INTROSPECTION_COMPILER STREQUAL "")
	message (FATAL_ERROR "GObject-Introspection was not found! Please install it to continue!")
endif (INTROSPECTION_COMPILER STREQUAL "")

set(COMPONENT_SOLVER_SOURCES
	solvers/abstract-solver.vala
	solvers/native-solver.vala
	solvers/python-solver.vala
	solvers/zfeed-solver.vala
	solvers/zfeed.vala
	solvers/feed-installer.vala
)

set(LISTALLER_GLIB_SOURCES ${LISTALLER_BASE_SOURCES}
	ipk-repo.vala
	ipk-changelog.vala
	dep-manager.vala
	dep-installer.vala
	dependency.vala
	component-factory.vala
	pkbackend-glue.vala
	pkit-tasks.vala
	signature.vala
	key-manager.vala
	repo-data.vala
	repo-list.vala
	repo-manager.vala
	manager.vala
	installer.vala
	updater.vala
	${COMPONENT_SOLVER_SOURCES}
)

list(APPEND VALA_INCLUDE_DIRS ${CMAKE_BINARY_DIR})

vala_add_library(listaller-glib SHARED ${LISTALLER_GLIB_SOURCES}
			BASE_DIR ${lisrc}
			VAPI_DIRS ${CMAKE_SOURCE_DIR}/vapi
			PACKAGES ${LISTALLER_BASE_VALA_DEPS} packagekit-glib2
			GENERATE_VAPI listaller-${LILIBS_VERSION}.vapi
			GENERATE_HEADER listaller.h
			GENERATE_INTERNAL_HEADER listaller_internal.h
			OUTPUT_DIR ${CMAKE_BINARY_DIR}/src
			COMPILE_FLAGS --gir=Listaller-${LILIBS_VERSION}.gir
				--library Listaller-${LILIBS_VERSION}
				--internal-vapi=listaller_internal.vapi.orig
				--thread
				${GLOBAL_VALAC_FLAGS}
)

find_program (SED_TOOL NAMES sed)
if (NOT SED_TOOL)
	message (FATAL_ERROR "Unable to find sed")
endif (NOT SED_TOOL)

# Workaround to fix Listaller header filename in internal vapi
add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/listaller_internal.vapi
	COMMAND ${SED_TOOL}  "'s/\"listaller.h\"/\"listaller_internal.h\"/'" ${CMAKE_CURRENT_BINARY_DIR}/listaller_internal.vapi.orig ">" ${CMAKE_CURRENT_BINARY_DIR}/listaller_internal.vapi
	DEPENDS listaller-glib_precompile ${CMAKE_CURRENT_BINARY_DIR}/listaller_internal.vapi.orig
)
add_custom_target(header_internal_fix DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/listaller_internal.vapi)
add_dependencies (listaller-glib header_internal_fix)

# Compile the introspection data
add_custom_target (gir-compile
	${INTROSPECTION_COMPILER}  "--shared-library=listaller-glib" "--includedir=."
				"${CMAKE_CURRENT_BINARY_DIR}/Listaller-${LILIBS_VERSION}.gir"
				"-o" "${CMAKE_CURRENT_BINARY_DIR}/Listaller-${LILIBS_VERSION}.typelib"
	DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/Listaller-${LILIBS_VERSION}.gir listaller-glib_precompile
	WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
)
add_dependencies (listaller-glib gir-compile)

add_definitions("-DI_KNOW_THE_PACKAGEKIT_GLIB2_API_IS_SUBJECT_TO_CHANGE"
	"-DI_KNOW_THE_PACKAGEKIT_PLUGIN_API_IS_SUBJECT_TO_CHANGE"
)

# Add log domain
add_definitions("-DG_LOG_DOMAIN=\"Listaller\"")

target_link_libraries(listaller-glib
		${M_LIB}
		${GEE_LIBRARIES}
		${GIO2_LIBRARIES}
		${SQLITE_LIBRARIES}
		${LibArchive_LIBRARIES}
		${LIBXML2_LIBRARIES}
		${GPGME_VANILLA_LIBRARIES}
		${SOUP_LIBRARIES}
		${PACKAGEKIT_LIBRARIES}
		${PACKAGEKIT_PLUGIN_LIBRARIES}
		${APPSTREAM_LIBRARIES}
)

include_directories(${CMAKE_BINARY_DIR}
		${CMAKE_CURRENT_SOURCE_DIR}
		${GLIB2_INCLUDE_DIR}
		${GEE_INCLUDE_DIRS}
		${GIO2_INCLUDE_DIR}
		${SQLITE_INCLUDE_DIR}
		${LibArchive_INCLUDE_DIR}
		${LIBXML2_INCLUDE_DIR}
		${GPGME_INCLUDES}
		${SOUP_INCLUDE_DIRS}
		${PACKAGEKIT_INCLUDE_DIRS}
		${PACKAGEKIT_PLUGIN_INCLUDE_DIRS}
		${APPSTREAM_INCLUDE_DIRS}
)

if(NOT LILIBS_FULL_VERSION)
 message(FATAL_ERROR "Library version not defined. (This should never happen)")
endif()
set_target_properties(listaller-glib PROPERTIES VERSION ${LILIBS_FULL_VERSION} SOVERSION ${LISTALLER_API_LEVEL})

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/listaller-glib.pc.in
  ${CMAKE_CURRENT_BINARY_DIR}/listaller-glib.pc
  @ONLY
)

install(TARGETS listaller-glib DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/listaller-glib.pc
	DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
	COMPONENT headers
)
install(FILES ${CMAKE_BINARY_DIR}/src/listaller.h
	DESTINATION include/listaller-glib
	COMPONENT headers
)
install(FILES ${CMAKE_BINARY_DIR}/src/listaller-${LILIBS_VERSION}.vapi
	DESTINATION share/vala/vapi
	COMPONENT headers
)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/Listaller-${LILIBS_VERSION}.gir
	DESTINATION share/gir-1.0
	COMPONENT headers
)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/Listaller-${LILIBS_VERSION}.typelib
	DESTINATION lib/girepository-1.0
	COMPONENT headers
)

#
# Build Listaller PackageKit PlugIn
#
add_subdirectory(pk-plugin)

=== tests/CMakeLists.txt ===
# CMakeLists for Listaller Unit Tests

find_package(Vala REQUIRED)
include("${VALA_USE_FILE}")

find_package(GLIB2 REQUIRED)
find_package(Gettext REQUIRED)
find_package(GPGMe REQUIRED)
find_package(GI REQUIRED)
find_library(M_LIB m)
pkg_check_modules(GEE REQUIRED gee-1.0)
pkg_check_modules(GIO2 REQUIRED gio-2.0)
pkg_check_modules(REDLAND REQUIRED redland>=0.4)
pkg_check_modules(PACKAGEKIT REQUIRED packagekit-glib2)
#find_gir(PKGIR "packagekit-glib2" REQUIRED)

set(LIUNITTEST_SOURCES testcommon.vala
)

link_libraries(${M_LIB}
		${GLIB2_LIBRARIES}
		${GEE_LIBRARIES}
		${GIO2_LIBRARIES}
		${LIBXML2_LIBRARIES}
		${GPGME_VANILLA_LIBRARIES}
		${PACKAGEKIT_LIBRARIES}
		${REDLAND_LIBRARIES}
		listaller-glib
)

include_directories(${CMAKE_BINARY_DIR}
		${CMAKE_BINARY_DIR}/src
		${CMAKE_CURRENT_SOURCE_DIR}
		${GLIB2_INCLUDE_DIR}
		${GEE_INCLUDE_DIRS}
		${GIO2_INCLUDE_DIR}
		${LIBXML2_INCLUDE_DIR}
		${GPGME_INCLUDES}
		${PACKAGEKIT_INCLUDE_DIRS}
		${APPSTREAM_INCLUDE_DIRS}
)

add_definitions ("-DI_KNOW_THE_PACKAGEKIT_GLIB2_API_IS_SUBJECT_TO_CHANGE")
add_definitions ("-DI_KNOW_THE_PACKAGEKIT_PLUGIN_API_IS_SUBJECT_TO_CHANGE")

# Basic tests
vala_add_executable (li-test-basics ${LIUNITTEST_SOURCES} tests-basics.vala
				BASE_DIR ${lisrc}
				PACKAGES ${LISTALLER_BASE_VALA_DEPS} packagekit-glib2 listaller_internal
				VAPI_DIRS ${CMAKE_SOURCE_DIR}/vapi ${CMAKE_BINARY_DIR}/src
				COMPILE_FLAGS ${GLOBAL_VALAC_FLAGS}
)
add_test(basic-test li-test-basics ${CMAKE_CURRENT_SOURCE_DIR})

# Database tests
vala_add_executable (li-test-database ${LIUNITTEST_SOURCES} tests-database.vala
				BASE_DIR ${lisrc}
				PACKAGES ${LISTALLER_BASE_VALA_DEPS} packagekit-glib2 listaller_internal
				VAPI_DIRS ${CMAKE_SOURCE_DIR}/vapi ${CMAKE_BINARY_DIR}/src
				COMPILE_FLAGS ${GLOBAL_VALAC_FLAGS}
)
add_test(database-test li-test-database)

# IPK layout tests
vala_add_executable (li-test-ipk ${LIUNITTEST_SOURCES} tests-ipk.vala
				BASE_DIR ${lisrc}
				PACKAGES ${LISTALLER_BASE_VALA_DEPS} packagekit-glib2 listaller_internal
				VAPI_DIRS ${CMAKE_SOURCE_DIR}/vapi ${CMAKE_BINARY_DIR}/src
				COMPILE_FLAGS ${GLOBAL_VALAC_FLAGS}
)
add_test(ipk-test li-test-ipk ${CMAKE_CURRENT_SOURCE_DIR})

# NOTE: lipkgen is part of LiTools, but it is essential for other tests to complete, so we don't exclude
# it here and instead depend on it. People who want to run tests need to be aware that this is intended
# behaviour.
# Lipkgen tests
vala_add_executable (li-test-ipkbuild ${LIUNITTEST_SOURCES} tests-ipkbuild.vala
				BASE_DIR ${lisrc}
				PACKAGES ${LISTALLER_BASE_VALA_DEPS} packagekit-glib2 listaller_internal
				VAPI_DIRS ${CMAKE_SOURCE_DIR}/vapi ${CMAKE_BINARY_DIR}/src
				COMPILE_FLAGS ${GLOBAL_VALAC_FLAGS}
)
add_test(ipkbuild-test li-test-ipkbuild ${CMAKE_CURRENT_SOURCE_DIR}
	${CMAKE_BINARY_DIR}/tools/appcompile/appcompile
	${CMAKE_BINARY_DIR}/tools/lipkgen/lipkgen
)
add_dependencies(li-test-ipkbuild lipkgen appcompile)

# IPK installer tests
vala_add_executable (li-test-installer ${LIUNITTEST_SOURCES} tests-installer.vala
				BASE_DIR ${lisrc}
				PACKAGES ${LISTALLER_BASE_VALA_DEPS} packagekit-glib2 listaller_internal
				VAPI_DIRS ${CMAKE_SOURCE_DIR}/vapi ${CMAKE_BINARY_DIR}/src
				COMPILE_FLAGS ${GLOBAL_VALAC_FLAGS}
)
add_test(installer-test li-test-installer ${CMAKE_CURRENT_SOURCE_DIR})

# IPK repo tests
vala_add_executable (li-test-repo ${LIUNITTEST_SOURCES} tests-repository.vala
				BASE_DIR ${lisrc}
				PACKAGES ${LISTALLER_BASE_VALA_DEPS} packagekit-glib2 listaller_internal
				VAPI_DIRS ${CMAKE_SOURCE_DIR}/vapi ${CMAKE_BINARY_DIR}/src
				COMPILE_FLAGS ${GLOBAL_VALAC_FLAGS}
)
add_test(repo-test li-test-repo ${CMAKE_CURRENT_SOURCE_DIR})

# Updater tests
vala_add_executable (li-test-updater ${LIUNITTEST_SOURCES} tests-updater.vala
				BASE_DIR ${lisrc}
				PACKAGES ${LISTALLER_BASE_VALA_DEPS} packagekit-glib2 listaller_internal
				VAPI_DIRS ${CMAKE_SOURCE_DIR}/vapi ${CMAKE_BINARY_DIR}/src
				COMPILE_FLAGS ${GLOBAL_VALAC_FLAGS}
)
add_test(updater-test li-test-updater ${CMAKE_CURRENT_SOURCE_DIR})

# Dependency solver tests
vala_add_executable (li-test-depmanager ${LIUNITTEST_SOURCES} tests-depmanager.vala
				BASE_DIR ${lisrc}
				PACKAGES ${LISTALLER_BASE_VALA_DEPS} packagekit-glib2 listaller_internal
				VAPI_DIRS ${CMAKE_SOURCE_DIR}/vapi ${CMAKE_BINARY_DIR}/src
				COMPILE_FLAGS ${GLOBAL_VALAC_FLAGS}
)
if(TEST_DEPMANAGER)
	add_test(depmanager-test li-test-depmanager ${CMAKE_CURRENT_SOURCE_DIR})
endif(TEST_DEPMANAGER)

# Tests of GPG signing
vala_add_executable (li-test-signing ${LIUNITTEST_SOURCES} tests-signing.vala
							../tools/lipkgen/lpkgutils.vala
							../tools/lipkgen/gpgsign.vala
				BASE_DIR ${lisrc}
				PACKAGES ${LISTALLER_BASE_VALA_DEPS} packagekit-glib2 listaller_internal
				VAPI_DIRS ${CMAKE_SOURCE_DIR}/vapi ${CMAKE_BINARY_DIR}/src
				COMPILE_FLAGS ${GLOBAL_VALAC_FLAGS}
)
if(TEST_SIGNING)
	add_test(signatures-test li-test-signing ${CMAKE_CURRENT_SOURCE_DIR})
endif(TEST_SIGNING)

# GPG Keydatabase tests
vala_add_executable (li-test-keydb ${LIUNITTEST_SOURCES} tests-keydb.vala
				BASE_DIR ${lisrc}
				PACKAGES ${LISTALLER_BASE_VALA_DEPS} packagekit-glib2 listaller_internal
				VAPI_DIRS ${CMAKE_SOURCE_DIR}/vapi ${CMAKE_BINARY_DIR}/src
				COMPILE_FLAGS ${GLOBAL_VALAC_FLAGS}
)
add_test(keydb-test li-test-keydb ${CMAKE_CURRENT_SOURCE_DIR})

=== tools/CMakeLists.txt ===
# CMakeLists for Listaller Tools Directory

find_package(GLIB2 REQUIRED)
find_package(Gettext REQUIRED)
find_package(SQLite3 REQUIRED)
find_package(LibArchive REQUIRED)
find_package(GPGMe REQUIRED)
find_library(M_LIB m)
pkg_check_modules(GEE REQUIRED gee-1.0)
pkg_check_modules(GIO2 REQUIRED gio-2.0)
pkg_check_modules(REDLAND REQUIRED redland>=0.4)
pkg_check_modules(PACKAGEKIT REQUIRED packagekit-glib2>=0.8.4)

set(LI_TOOLS_SHARED_SOURCES toolshared.vala
			console-progress-bar.vala
			reporting.vala
)

vala_precompile(tools-shared LI_TOOLS_SHARED_C ${LI_TOOLS_SHARED_SOURCES}
			PACKAGES config gee-1.0 gio-2.0 posix appstream listaller-${LILIBS_VERSION}
			VAPI_DIRS ${CMAKE_SOURCE_DIR}/vapi ${CMAKE_BINARY_DIR}/src
)

# prepare workspace for tool compilation
include_directories(${CMAKE_BINARY_DIR}
		    ${CMAKE_BINARY_DIR}/src
		    ${CMAKE_CURRENT_SOURCE_DIR}
		    ${GLIB2_INCLUDE_DIR}
		    ${GEE_INCLUDE_DIRS}
		    ${GIO2_INCLUDE_DIR}
		    ${SQLITE_INCLUDE_DIR}
		    ${LibArchive_INCLUDE_DIR}
		    ${LIBXML2_INCLUDE_DIR}
		    ${GPGME_INCLUDES}
		    ${APPSTREAM_INCLUDE_DIRS}
		    ${PACKAGEKIT_INCLUDE_DIRS}
)

add_definitions("-DI_KNOW_THE_PACKAGEKIT_GLIB2_API_IS_SUBJECT_TO_CHANGE")

add_subdirectory(runapp)
add_subdirectory(lipa)
add_subdirectory(likey)
if(TOOLS)
	add_subdirectory(depscan)
	add_subdirectory(lipkgen)
#	add_subdirectory(lilith)
	add_subdirectory(appcompile)
	add_subdirectory(lirepo)
endif(TOOLS)

=== contrib/binreloc/CMakeLists.txt ===
# CMakeLists for BinReloc

set(BINRELOC_FILES basic.c
		binreloc.m4
		fdbr-test.c
		fdbr.c
		generate.pl
		glib.c
		normal.c
		README
)

set(BINRELOC_JAVA java/BinReloc.java)
set(BINRELOC_MONO mono/BinReloc.cs
		mono/Readme.txt
)
set(BINRELOC_PYTHON python/reloc.py
		python/reloc.txt
		python/testreloc.py
)

set(BINRELOC_DOC "")

# TODO: Generate & install documentation

install(FILES ${BINRELOC_FILES} DESTINATION share/listaller/binreloc COMPONENT binreloc)

install(FILES ${BINRELOC_JAVA} DESTINATION share/listaller/binreloc/java COMPONENT binreloc)
install(FILES ${BINRELOC_MONO} DESTINATION share/listaller/binreloc/mono COMPONENT binreloc)
install(FILES ${BINRELOC_PYTHON} DESTINATION share/listaller/binreloc/python COMPONENT binreloc)

=== data/etc/CMakeLists.txt ===
# Install standard configuration

# changeable config files
install(FILES Listaller.conf
	      depscan-ignore.list
	DESTINATION ${SYSCONF_INSTALL_DIR}/listaller
	COMPONENT config
)

=== data/metainfo-templates/CMakeLists.txt ===
# CMakeLists for default component templates

# find metainfo templates and add README
file (GLOB_RECURSE METAINFO_TEMPLATE_DATA "${CMAKE_CURRENT_SOURCE_DIR}/*.metainfo.xml")
set(METAINFO_TEMPLATE_DATA ${METAINFO_TEMPLATE_DATA} README)

install(FILES ${METAINFO_TEMPLATE_DATA}
	DESTINATION ${DATA_INSTALL_DIR}/metainfo-templates
)

=== docs/man/CMakeLists.txt ===
# CMakeLists for manual page docs

include (${CMAKE_SOURCE_DIR}/data/cmake/documentation.cmake)

set(manpages "runapp.1"
	"lipa.1"
	"likey.1"
)

if(TOOLS)
	set(manpages ${manpages}
		"lipkgen.1"
		"appcompile.1"
		"depscan.1"
	)
endif()

if(LIBUILD)
	set(manpages ${manpages}
		"ligcc.1"
		"lig++.1"
		"relaytool.1"
	)
endif()

add_xml_manpages(doc-man "${manpages}" "" "")

=== src/pk-plugin/CMakeLists.txt ===
# CMakeLists for Listaller PackageKit PlugIn

find_package(GLIB2 REQUIRED)
pkg_check_modules(GEE REQUIRED gee-1.0)
pkg_check_modules(GIO2 REQUIRED gio-2.0)
pkg_check_modules(PACKAGEKIT REQUIRED packagekit-glib2)
pkg_check_modules(PACKAGEKIT_PLUGIN REQUIRED packagekit-plugin)
#find_gir(PKGIR "PackageKitGlib-1.0" REQUIRED)

set(PK_LISTALLER_SOURCES
	li-plugin-utils.h
	li-plugin-utils.c
	pk-plugin-listaller.c
)

add_library(pk_plugin_listaller MODULE ${PK_LISTALLER_SOURCES})

target_link_libraries(pk_plugin_listaller
		${M_LIB}
		${GEE_LIBRARIES}
		${GIO2_LIBRARIES}
		${PACKAGEKIT_LIBRARIES}
		${PACKAGEKIT_PLUGIN_LIBRARIES}
		listaller-glib
)

include_directories(${CMAKE_BINARY_DIR}
		${CMAKE_BINARY_DIR}/src
		${CMAKE_CURRENT_SOURCE_DIR}
		${GLIB2_INCLUDE_DIR}
		${GEE_INCLUDE_DIRS}
		${GIO2_INCLUDE_DIR}
		${PACKAGEKIT_INCLUDE_DIRS}
		${PACKAGEKIT_PLUGIN_INCLUDE_DIRS}
)

remove_definitions("-DG_LOG_DOMAIN=\"Listaller\"")
add_definitions("-Werror -g")
add_definitions("-DG_LOG_DOMAIN=\"PkListaller\"")

if(NOT LILIBS_FULL_VERSION)
 message(FATAL_ERROR "Library version not defined. (This should never happen)")
endif()
# set_target_properties(pk_plugin_listaller PROPERTIES VERSION ${LILIBS_FULL_VERSION} SOVERSION ${LISTALLER_API_LEVEL})

#install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libpk_plugin_listaller.so.${LILIBS_FULL_VERSION}
#	DESTINATION ${LIB_INSTALL_DIR}/packagekit-plugins
#	RENAME libpk_plugin_listaller.so
#)

install(TARGETS pk_plugin_listaller DESTINATION ${LIB_INSTALL_DIR}/packagekit-plugins-2)

=== tools/appcompile/CMakeLists.txt ===
# CMakeLists for Listaller package builder tool
project(listaller-appcompile)

find_package(Vala REQUIRED)
include("${VALA_USE_FILE}")

find_package(GLIB2 REQUIRED)
find_package(Gettext REQUIRED)
pkg_check_modules(GEE REQUIRED gee-1.0)
pkg_check_modules(GIO2 REQUIRED gio-2.0)

set(LIBUILD_SOURCES ${lisrc}/utils.vala
			${lisrc}/logging.vala
			../lipkgen/lpkgutils.vala
			acutils.vala
			appcompile.vala
			autocompiler.vala
			autostrip.vala
)

include_directories(${CMAKE_BINARY_DIR}
		    ${CMAKE_CURRENT_SOURCE_DIR}
		    ${GLIB2_INCLUDE_DIR}
		    ${GEE_INCLUDE_DIRS}
		    ${GIO2_INCLUDE_DIR}
)

# Database tests
vala_add_executable (appcompile ${LIBUILD_SOURCES}
			PACKAGES config gee-1.0 gio-2.0 posix
			VAPI_DIRS ${CMAKE_SOURCE_DIR}/vapi
			COMPILE_FLAGS ${GLOBAL_VALAC_FLAGS}
)

target_link_libraries(appcompile
		${GLIB2_LIBRARIES}
		${GEE_LIBRARIES}
		${GIO2_LIBRARIES}
)

install(TARGETS appcompile DESTINATION bin)

=== debian/changelog ===
listaller (0.5.9-4) unstable; urgency=medium

  * Add patch to support recent AppStream GIR API (Closes: #765105)

 -- Matthias Klumpp <mak@debian.org>  Mon, 13 Oct 2014 21:26:34 +0200

listaller (0.5.9-3) unstable; urgency=medium

  * Drop the PackageKit plugin
    - This is due to PackageKit 1.0 removing support for it. This
      means that Listaller-installed apps can not be managed using
      GUI-tools like Apper or GNOME-Software anymore. The next release of
      Listaller is going to address that, but it will not be ready in-time
      for Jessie.
    - Please use the 'lipa' command to manage installed Listaller apps
      for now.
    - All other Listaller commands, including the libuild facilities,
      are unaffected by this change.

 -- Matthias Klumpp <mak@debian.org>  Thu, 25 Sep 2014 14:38:42 +0200

listaller (0.5.9-2) unstable; urgency=medium

  * Add patch to compile against latest libgee (Closes: #753870)

 -- Matthias Klumpp <mak@debian.org>  Tue, 09 Sep 2014 01:08:34 +0200

listaller (0.5.9-1) unstable; urgency=medium

  * New upstream release: 0.5.9
    - Closes: #742144
  * Drop patches: Applied upstream
  * Don't depend on Redland

 -- Matthias Klumpp <mak@debian.org>  Mon, 08 Sep 2014 19:14:24 +0200

=== debian/control ===
Source: listaller
Section: admin
Priority: optional
Maintainer: Matthias Klumpp <mak@debian.org>
Build-Depends: cmake (>= 2.8),
               debhelper (>= 9.0.0),
               intltool,
               libappstream-dev (>= 0.7.1),
               libarchive-dev (>= 2.8),
               libgee-0.8-dev (>= 0.14),
               libgirepository1.0-dev,
               libglib2.0-dev (>= 2.28),
               libgpgme11-dev,
               libpackagekit-glib2-dev (>= 0.9.5-2),
               libpolkit-gobject-1-dev,
               libsoup2.4-dev (>= 2.40),
               libsqlite3-dev (>= 3.6),
               libxml2-dev,
               valac (>= 0.20),
               xmlto
Standards-Version: 3.9.6
Homepage: http://listaller.tenstral.net
Vcs-Git: git://anonscm.debian.org/pkg-packagekit/listaller.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-packagekit/listaller.git

Package: listaller
Architecture: any
Multi-Arch: foreign
Depends: liblistaller-glib0 (>= ${binary:Version}),
         packagekit (>= 0.8.4),
         ${misc:Depends},
         ${shlibs:Depends}
Description: 3rd-party application installer
 Listaller is a distro-agnostic 3rd-party application installer
 with close integration into PackageKit.
 The project uses GPG-signed software packages with minimal
 permissions, making 3rd-party installations as simple
 and secure as possible.
 .
 Dependencies are resolved automatically using PackageKit.
 Listaller applications can be installed and removed using any
 PackageKit frontend, without having to use additional tools.
 .
 This package contains all modules required for Listaller to work.

Package: liblistaller-glib0
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: listaller (= ${binary:Version})
Description: 3rd-party application installer (shared library)
 Listaller is a distro-agnostic 3rd-party application installer
 with close integration into PackageKit.
 The project uses GPG-signed software packages with minimal
 permissions, making 3rd-party installations as simple
 and secure as possible.
 .
 Dependencies are resolved automatically using PackageKit.
 Listaller applications can be installed and removed using any
 PackageKit frontend, without having to use additional tools.
 .
 This package contains the Listaller shared library.

Package: liblistaller-glib-dev
Architecture: any
Section: libdevel
Depends: libgee-0.8-dev,
         libglib2.0-dev (>= 2.28),
         liblistaller-glib0 (= ${binary:Version}),
         ${misc:Depends}
Description: 3rd-party application installer (development files)
 Listaller is a distro-agnostic 3rd-party application installer
 with close integration into PackageKit.
 The project uses GPG-signed software packages with minimal
 permissions, making 3rd-party installations as simple
 and secure as possible.
 .
 Dependencies are resolved automatically using PackageKit.
 Listaller applications can be installed and removed using any
 PackageKit frontend, without having to use additional tools.
 .
 This package contains development files necessary to develop
 custom Listaller frontends.

Package: gir1.2-listaller-0.5
Section: introspection
Architecture: any
Depends: ${gir:Depends},
         ${misc:Depends}
Description: GObject introspection data for the Listaller library
 Listaller is a distro-agnostic 3rd-party application installer
 with close integration into PackageKit.
 Applications can be installed and removed using any
 PackageKit frontend, without having to use additional tools.
 .
 This package contains introspection data for the Listaller
 interface library.
 .
 It can be used by packages using the GIRepository format to generate
 dynamic bindings.

Package: listaller-devtools
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: listaller-libuild
Description: 3rd-party application installer packaging tools
 Listaller is a distro-agnostic 3rd-party application installer
 with close integration into PackageKit.
 Applications can be installed and removed using any
 PackageKit frontend, without having to use additional tools.
 .
 This package contains tools which are required to build
 and maintain your own IPK packages.

Package: listaller-libuild
Architecture: any
Depends: gcc,
         make,
         perl (>= 5.14),
         ${misc:Depends},
         ${perl:Depends},
         ${shlibs:Depends}
Suggests: build-essential
Description: Listaller libuild facilities
 Listaller is a distro-agnostic 3rd-party application installer
 with close integration into PackageKit.
 Applications can be installed and removed using any
 PackageKit frontend, without having to use additional tools.
 .
 This package contains the libuild facilities, which help building
 more portable applications.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
#export DH_VERBOSE=1

export DEB_BUILD_HARDENING=1

LI_CONFIGURE_ARGS = -DTOOLS=ON \
		    -DLIBUILD=ON


# Define install target dir
INSTALLDIR = $(CURDIR)/debian/tmp

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(LI_CONFIGURE_ARGS)

override_dh_auto_install:
	dh_auto_install --destdir=$(INSTALLDIR)

	# Make sure script still has x-right
	chmod +x $(INSTALLDIR)/usr/share/listaller/binreloc/generate.pl

override_dh_install:
	dh_install --list-missing

override_dh_auto_test:
	# Skip this, the tests are not meant to run unsupervised at time
